/**************************************************************
    Project by Beycan Kahraman             on   26.11.2005
    
                      ODEV - 3             SORU - 4
**************************************************************/
/*
#include <iostream.h>                 
#include <winbgim.cpp>
#include <math.h>

using namespace std;

#define GENISLIK 	800
#define YUKSEKLIK 	600
#define MAKSIMUM 	100
#define RENK_NOKTA	15
#define RENK_SPL1	12
#define RENK_SPL2	14
#define RENK_DOGRU 	8
#define SPLINE_ART 	0.01

class Nokta{
	int x, y;
	public:
		void Degistir(int a = 0, int b = 0){
			x = a;
			y = b;
		}
		int getX(){ return x; }
		int getY(){ return y; }
};

class BSpline{
	Nokta *nokta;
	static int NoktaSayisi;
	public:
		BSpline(){
			nokta = new Nokta[MAKSIMUM];
		}
		static void Basla(){
            NoktaSayisi = 0;
        }
        void NoktaEkle(int x, int y){
			if(NoktaSayisi > MAKSIMUM - 2)
				return;
			nokta[NoktaSayisi++].Degistir(x, y);
			cout << "Ekle " << NoktaSayisi << endl;
		}
		void NoktaCikar(int x, int y){
			if(NoktaSayisi < 1)
				return;
			int min = 1000000, kac = 0;
			for(int i=0; i<NoktaSayisi; i++)
				if((nokta[i].getX()-x)*(nokta[i].getX()-x) + (nokta[i].getY()-y)*(nokta[i].getY()-y) < min){
					min = (nokta[i].getX()-x)*(nokta[i].getX()-x) + (nokta[i].getY()-y)*(nokta[i].getY()-y);
					kac = i;
				}
			for(int i = kac; i < NoktaSayisi; i++){
				nokta[i].Degistir(nokta[i+1].getX(), nokta[i+1].getY());
			}
			NoktaSayisi--;
			cout << "Cikar " << NoktaSayisi << endl;
		}
		void NoktaDegistir(int x, int y){
			if(NoktaSayisi < 1)
				return;
			int min = 1000000, kac = 0;
			for(int i=0; i<NoktaSayisi; i++)
				if((nokta[i].getX()-x)*(nokta[i].getX()-x) + (nokta[i].getY()-y)*(nokta[i].getY()-y) < min){
					min = (nokta[i].getX()-x)*(nokta[i].getX()-x) + (nokta[i].getY()-y)*(nokta[i].getY()-y);
					kac = i;
				}
			nokta[kac].Degistir(x, y);
		}
		void NoktaCiz(){
			setcolor(RENK_NOKTA);
			for(int i=0; i<NoktaSayisi; i++)
			    rectangle(nokta[i].getX()-2, nokta[i].getY()-2, nokta[i].getX()+2, nokta[i].getY()+2);
		}
		void DogruCiz(){
			setcolor(RENK_DOGRU);
			for(int i=0; i<NoktaSayisi - 1; i++)
				line(nokta[i].getX(), nokta[i].getY(), nokta[i+1].getX(), nokta[i+1].getY());
		}
		void SplineCiz(){
			float t;
			int cizX[4], cizY[4];
			if(NoktaSayisi > 3){
				for(int j=0; j<NoktaSayisi - 3; j++){
					for(int i=0; i<4; i++){
						cizX[i] = nokta[i + j].getX();
						cizY[i] = nokta[i + j].getY();
					}
					t = 0;
					if(j%2 == 0) setcolor(RENK_SPL1);
					else setcolor(RENK_SPL2);
					while(t < 1 - SPLINE_ART){
						line(spline_IV(cizX,t), spline_IV(cizY,t), spline_IV(cizX,t+SPLINE_ART), spline_IV(cizY,t+SPLINE_ART));
						t += SPLINE_ART;
					}
				}
			}
		}
		friend int spline_IV(int *X, float t);
};

int BSpline::NoktaSayisi;
int NeYapacagiz = 0;
bool basma = false;

BSpline bSpline;

void click_handler(int a, int b){
	if(b < 20 && b > 10){
		if(a < 48 && a > 38)
			NeYapacagiz = 2;
		else if(a < 34 && a > 24)
			NeYapacagiz = 1;
		else if(a < 20 && a > 10)
			NeYapacagiz = 0;
		return;
	}
	basma = true;
	if(NeYapacagiz == 0)
		bSpline.NoktaEkle(a, b);
	else if(NeYapacagiz == 1)
		bSpline.NoktaCikar(a, b);
	else
		bSpline.NoktaDegistir(a, b);
}
void move_handler(int a, int b){
	if(basma && NeYapacagiz == 2)
		bSpline.NoktaDegistir(a, b);
}
void up_handler(int a, int b){
	basma = false;
}
void SecmeMenusu(){
	setcolor(2);
	rectangle(10,10,20,20);
	setcolor(4);
	rectangle(24,10,34,20);
	setcolor(1);
	rectangle(38,10,48,20);
}
int spline_IV(int *X, float t){
    return (int)((-X[0] + 3*X[1] - 3*X[2] + X[3])*t*t*t / 6 + (X[0] - 2*X[1] + X[2])*t*t / 2 + (-X[0] + X[2])*t / 2 + (X[0] + 4*X[1] + X[2]) / 6);
}

//	ANA PROGRAMA BASLIYORUZ

int main(){
    int i;
	int a = 0;
	
	bSpline.Basla();

	initwindow( GENISLIK, YUKSEKLIK );
	registermousehandler( WM_LBUTTONDOWN, click_handler );
	registermousehandler( WM_MOUSEMOVE, move_handler );
	registermousehandler( WM_LBUTTONUP, up_handler );

	while(!kbhit()){
		a = (a+1)%2;
		setactivepage(a%2);
		clearviewport();
		
		SecmeMenusu();
		bSpline.NoktaCiz();
		bSpline.DogruCiz();
		bSpline.SplineCiz();
		
		setvisualpage(a%2);
	}
	return 1;
}
*/
